#include <ESP8266WiFi.h>
#include "osapi.h"
#include "os_type.h"

int *LEDpattern_ptr;
int LEDpattern_index;
unsigned long LED_now = 0;
unsigned long LED_nextTime = 0;
os_timer_t led_timer;

void LED_setup() {
  pinMode(LED_PIN, OUTPUT);
  LED_now = 0;
  LED_nextTime = 0;

  os_timer_disarm(&led_timer);
  os_timer_setfn(&led_timer, (os_timer_func_t *)loop_LED, NULL);
  os_timer_arm(&led_timer, 10, 1);
}

void LED(int *pattern) {
  LEDpattern_ptr = pattern;
  LEDpattern_index = 0;
  LED_nextTime = 0;
  loop_LED();
}

void loop_LED() {
  if (LEDpattern_ptr == 0) return;
  //
  LED_now = LED_now + 10;
  if ((LED_now>=LED_nextTime) || (LED_nextTime==0)) {
    int *ptr  = LEDpattern_ptr;
    int count = *ptr++;
    digitalWrite(LED_PIN, ptr[(LEDpattern_index*2)+0]);
    LED_nextTime = LED_now + ptr[(LEDpattern_index*2)+1];
    LEDpattern_index++;
    if (LEDpattern_index>=count) { LEDpattern_index = 0; }
  }
}

