// ------------------------------------------------------------
//   ペアリングモード
// ------------------------------------------------------------
const String THETA_SSID_PREFIX = "THETA";
const String THETAm15_SSID_PREFIX = "THETAXN";

void initialize_scan() {
  LED(Pattern_Pairing);
  Serial.println("Pairing mode...");

  //WiFiクライアントモード設定
  WiFi.mode(WIFI_STA);
}

void loop_scan() {
  int nMaxRSSI = THETA_RSSI_THRESHOLD;
  int nThetaIndex = -1;
  int n = WiFi.scanNetworks();
  String SSIDName,Password;

  Serial.println("Scanning...");
  for (int i = 0; i < n; ++i) {
    SSIDName = WiFi.SSID(i);
    if (SSIDName.startsWith(THETA_SSID_PREFIX) || SSIDName.startsWith(THETAm15_SSID_PREFIX)) {
      if (nMaxRSSI<WiFi.RSSI(i)) {
        nThetaIndex = i;
      }
    }
  }

  if (nThetaIndex >= 0) {
    LED(Pattern_Paired);
    
    Serial.print("THETA found :");
    SSIDName = WiFi.SSID(nThetaIndex);
    nMaxRSSI = WiFi.RSSI(nThetaIndex);

    if (SSIDName.startsWith(THETAm15_SSID_PREFIX)) {
      Password = SSIDName.substring(THETAm15_SSID_PREFIX.length());
    } else if (SSIDName.startsWith(THETA_SSID_PREFIX)) {
      Password = SSIDName.substring(THETA_SSID_PREFIX.length());    
    }
    //
    Serial.print("SSID["+SSIDName+"] Password["+Password+"] RSSI(");
    Serial.print(nMaxRSSI);
    Serial.println(")");
    //
    THETA_SSID = SSIDName;
    THETA_Password = Password;
    WriteSettings();

    // ペアリング完了→シャッターモードへ
    gotoShutterMode();
  }

  delay(1000);
}

